package com.ekexiu.console.system.dao;

import com.ekexiu.console.system.po.ViewCustomer;
import org.jfw.apt.annotation.Nullable;
import org.jfw.apt.orm.annotation.dao.DAO;
import org.jfw.apt.orm.annotation.dao.method.OrderBy;
import org.jfw.apt.orm.annotation.dao.method.operator.PageSelect;
import org.jfw.apt.orm.annotation.dao.method.operator.SelectOne;
import org.jfw.apt.orm.annotation.dao.param.Like;
import org.jfw.util.PageQueryResult;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;

@DAO
public abstract class ViewCustomerDao {
	@Nullable
	@SelectOne
	public abstract ViewCustomer query(Connection con, String id) throws SQLException;
	
	@PageSelect
	@OrderBy(" ORDER BY create_time")
	public abstract PageQueryResult<ViewCustomer> query(Connection con, @Like String name, @Like String address, @Like String orgname, @Nullable Integer sendMailStatus, int pageSize, int pageNo) throws SQLException;

	public List<ViewCustomer> orgName(Connection con,String orgname) throws SQLException{
		int index = 1;
		boolean oname = null == orgname;
		StringBuilder sql = new StringBuilder();
		sql.append("SELECT ORGNAME FROM view_customer");
		if(!oname){
			sql.append(" WHERE ORGNAME LIKE ? group by orgname");
		}
		PreparedStatement ps = con.prepareStatement(sql.toString());
		try{
			if(!oname){
				ps.setString(index++,orgname);
			}
			ResultSet rs = ps.executeQuery();
			try{
				List<ViewCustomer> viewCustomers = new ArrayList<ViewCustomer>();
				while(rs.next()){
					ViewCustomer viewCustomer =  new ViewCustomer();
					String orgName = rs.getString(1);
					if(rs.wasNull()){
						orgName = null;
					}
					viewCustomer.setOrgname(orgName);
					viewCustomers.add(viewCustomer);
				}
				return viewCustomers;
			}finally{
				try{rs.close();}catch(Exception e){}
			}
		}finally{
			try{ps.close();}catch(Exception e){}
		}
	}
}
